'use strict';

var process$1 = require('process');
var boxen = require('@visulima/boxen');
var colorize = require('@visulima/colorize');
var server = require('@visulima/pail/server');
var mt = require('command-line-args');
var w = require('cli-table3');
var ye = require('@visulima/colorize/template');
var Oe = require('os');
var fastestLevenshtein = require('fastest-levenshtein');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var mt__default = /*#__PURE__*/_interopDefault(mt);
var w__default = /*#__PURE__*/_interopDefault(w);
var ye__default = /*#__PURE__*/_interopDefault(ye);
var Oe__default = /*#__PURE__*/_interopDefault(Oe);

var me=/[\p{Lu}]/u,ce=/[\p{Ll}]/u,U=/^[\p{Lu}](?![\p{Lu}])/gu,j=/([\p{Alpha}\p{N}_]|$)/u,v=/[_.\- ]+/,de=new RegExp("^"+v.source),k=new RegExp(v.source+j.source,"gu"),M=new RegExp("\\d+"+j.source,"gu"),ge=(o,e,t,i)=>{let s=!1,n=!1,r=!1,a=!1;for(let l=0;l<o.length;l++){let c=o[l];a=l>2?o[l-3]==="-":!0,s&&me.test(c)?(o=o.slice(0,l)+"-"+o.slice(l),s=!1,r=n,n=!0,l++):n&&r&&ce.test(c)&&(!a||i)?(o=o.slice(0,l-1)+"-"+o.slice(l-1),r=n,n=!1,s=!0):(s=e(c)===c&&t(c)!==c,r=n,n=t(c)===c&&e(c)!==c);}return o},ue=(o,e)=>(U.lastIndex=0,o.replaceAll(U,t=>e(t))),fe=(o,e)=>(k.lastIndex=0,M.lastIndex=0,o.replaceAll(M,(t,i,s)=>["_","-"].includes(o.charAt(s+t.length))?t:e(t)).replaceAll(k,(t,i)=>e(i)));function I(o,e){if(!(typeof o=="string"||Array.isArray(o)))throw new TypeError("Expected the input to be `string | string[]`");if(e={pascalCase:!1,preserveConsecutiveUppercase:!1,...e},Array.isArray(o)?o=o.map(n=>n.trim()).filter(n=>n.length).join("-"):o=o.trim(),o.length===0)return "";let t=e.locale===!1?n=>n.toLowerCase():n=>n.toLocaleLowerCase(e.locale),i=e.locale===!1?n=>n.toUpperCase():n=>n.toLocaleUpperCase(e.locale);return o.length===1?v.test(o)?"":e.pascalCase?i(o):t(o):(o!==t(o)&&(o=ge(o,t,i,e.preserveConsecutiveUppercase)),o=o.replace(de,""),o=e.preserveConsecutiveUppercase?ue(o,t):t(o),e.pascalCase&&(o=i(o.charAt(0))+o.slice(1)),fe(o,i))}var he=[{description:"Turn on verbose output",group:"global",name:"verbose",type:Boolean},{description:"Turn on debugging output",group:"global",name:"debug",type:Boolean},{alias:"h",description:"Print out helpful usage information",group:"global",name:"help",type:Boolean},{alias:"q",description:"Silence output",group:"global",name:"quiet",type:Boolean},{alias:"V",description:"Print version info",group:"global",name:"version",type:Boolean},{description:"Turn off colored output",group:"global",name:"no-color",type:Boolean},{description:"Force colored output",group:"global",name:"color",type:Boolean}],y=he;var be=o=>o?ye__default.default(Object.assign([],{raw:[o.replaceAll("`","\\`")]})):"",m=be;var x=class{lines;constructor(){this.lines=[];}add(e){this.lines.push(e);}toString(){return this.lines.join(Oe__default.default.EOL)}header(e){this.add(colorize.bold(e)),this.lines.push("");}},C=x;var T={chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,60],style:{border:[],compact:!0,head:[],"padding-left":2,"padding-right":1},wordWrap:!0},N=class extends C{constructor(e){if(super(),e.header&&this.header(m(e.header)),e.content){if(e.raw)if(Array.isArray(e.content)&&e.content.every(t=>typeof t=="string"))e.content.forEach(t=>{Array.isArray(t)?t.forEach(i=>this.add(m(i))):this.add(m(t));});else if(typeof e.content=="string")this.add(m(e.content));else throw new TypeError("Invalid raw content, must be a string or array of strings.");else this.add(this.getContentLines(e.content));this.add("");}}getContentLines(e){if(typeof e=="string"){let t=new w__default.default({...T,colWidths:[80]});return t.push([m(e)]),t.toString()}if(Array.isArray(e)&&e.every(t=>typeof t=="string"||Array.isArray(t)&&t.every(i=>typeof i=="string"))){let t=new w__default.default({...T});return e.forEach(i=>{Array.isArray(i)?t.push(i.map(s=>m(s))):t.push([m(i)]);}),t.toString()}if(typeof e=="object"){let t=e;if(!t.options||!t.data)throw new Error(`Must have an "options" or "data" property
${JSON.stringify(e)}`);let i=new w__default.default({...T,...t.options,style:{...T.style,...t.options.style}});return t.data.forEach(s=>{Array.isArray(s)?i.push(s.map(n=>m(n))):i.push([m(s)]);}),i.toString()}throw new Error(`invalid input - 'content' must be a string, array of strings or a object:

${JSON.stringify(e)}`)}},Y=N;var A=class extends C{constructor(e){super();let t=e.optionList??[],i=Array.isArray(e.hide)?e.hide:[e.hide].filter(Boolean),s=Array.isArray(e.group)?e.group:[e.group].filter(Boolean);i.length>0&&(t=t.filter(r=>!i.includes(r.name))),e.header&&this.header(m(e.header)),s.length>0&&(t=t.filter(r=>{let a=s.includes("_none")&&!r.group,l=this.intersect(Array.isArray(r.group)?r.group:[r.group],s);return a||l?r:void 0}));let n=new w__default.default({chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,40],style:{"padding-left":2,"padding-right":1},wordWrap:!0});t.forEach(r=>n.push([this.getOptionNames(r,e.reverseNameOrder??!1,e.isArgument??!1),m(r.description)])),this.add(n.toString()),this.lines.push("");}getOptionNames(e,t,i){if(!e.name)throw new TypeError("Invalid option definition, name is required.");let s=e.type?e.type.name.toLowerCase():"string",n=e.multiple||e.lazyMultiple?"[]":"";s=m(e.typeLabel??`{underline ${s}${n}}`);let r;if(e.alias)if(e.name){let a=i?e.name:`{yellow --${e.name}}`;r=t?m(`{bold ${a}}, {bold -${e.alias}} ${s}`):m(`{bold -${e.alias}}, {bold ${a}} ${s}`);}else t?r=m(`{bold -${e.alias}} ${s}`):r=m(`{bold -${e.alias}} ${s}`);else r=m(`{bold ${i?e.name:`{yellow --${e.name}}`}} ${s}`);return r}intersect(e,t){return e.some(i=>t.includes(i))}},F=A;var Ee=o=>(Array.isArray(o)?o:[o]).length===0?"":`
${o.map(t=>t.optionList?new F(t).toString():new Y(t).toString()).join(`
`)}`,L=Ee;var G="__Other",q=o=>o.charAt(0).toUpperCase()+o.slice(1),ve=(o,e,t,i)=>{o.debug("no command given, printing general help...");let s=[...new Set(t.values())].filter(r=>!r.hidden);i&&(s=s.filter(r=>r.group===i));let n=s.reduce((r,a)=>{let l=a.group??G;return r[l]||(r[l]=[]),r[l].push(a),r},{});o.raw(L([{content:`{cyan ${e.getCliName()}} {green <command>} [positional arguments] {yellow [options]}`,header:"{inverse.cyan  Usage }"},...Object.keys(n).map(r=>({content:n[r].map(a=>{let l="";return typeof a.alias=="string"?l=a.alias:Array.isArray(a.alias)&&(l=a.alias.join(", ")),l!==""&&(l=` [${l}]`),[`{green ${a.name}} ${l}`,a.description??""]}),header:r===G||i?`{inverse.green  Available${i?` ${q(i)}`:""} Commands }`:` {inverse.green  ${q(r)} }`})),t.has("help")?{header:"{inverse.yellow  Command Options }",optionList:t.get("help").options?.filter(r=>!r.hidden)}:void 0,{header:"{inverse.yellow  Global Options }",optionList:y},{content:`Run "{cyan ${e.getCliName()}} {green help <command>}" or "{cyan ${e.getCliName()}} {green <command>} {yellow --help}" for help with a specific command.`,raw:!0}].filter(Boolean)));},Ie=(o,e,t,i)=>{let s=t.get(i),n=[];if(n.push({content:`{cyan ${e.getCliName()}} {green ${s.name}}${s.argument?" [positional arguments]":""}${s.options?" [options]":""}`,header:"{inverse.cyan  Usage }"}),s.description&&n.push({content:s.description,header:"{inverse.green  Description }"}),s.argument&&n.push({header:"Command Positional Arguments",isArgument:!0,optionList:[s.argument]}),Array.isArray(s.options)&&s.options.length>0&&n.push({header:"{inverse.yellow  Command Options }",optionList:s.options.filter(r=>!r.hidden)}),n.push({header:"{inverse.yellow  Global Options }",optionList:y}),s.alias!==void 0&&s.alias.length>0){let r=s.alias;typeof s.alias=="string"&&(r=[s.alias]),n.splice(1,0,{content:r,header:"Alias(es)"});}Array.isArray(s.examples)&&s.examples.length>0&&n.push({content:s.examples,header:"Examples"}),o.raw(L(n));},P=class{name="help";options=[{description:"Display only the specified group",name:"group",type:String}];commands;constructor(e){this.commands=e;}execute(e){let{commandName:t,logger:i,options:s,runtime:n}=e,{footer:r,header:a}=n.getCommandSection();a&&i.raw(m(a)),t==="help"?ve(i,n,this.commands,s?.group):Ie(i,n,this.commands,t),r&&i.raw(m(r));}},J=P;var W={alias:["v","V"],description:"Output the version number",execute:({logger:o,runtime:e})=>{let t=e.getPackageVersion();t===void 0?(o.warn("Unknown version"),o.debug("The version number was not provided by the cli constructor.")):o.info(t);},name:"version",options:[],usage:[]};var O="positionals";var _=class{result;argv;options;argument;command;commandName;runtime;logger;constructor(e,t){this.commandName=e,this.command=t;}},H=_;var xe=()=>{let o=process.env.CEREBRO_MIN_NODE_VERSION?Number(process.env.CEREBRO_MIN_NODE_VERSION):18,e=process.version.replace("v","");Number(/v([^.]+)/.exec(process.version)[1])<o&&(console.log(`cerebro supports a minimum Node version of ${o}. You have ${e}. Read our version support policy: https://github.com/visulima/visulima#supported-nodejs-versions`),process.exit(1));},K=xe;var we=/^-{1,2}(\w+)(=(\w+))?$/,Ne=(o,e)=>{let t=we.exec(o);if(t==null)return {};let i=t[1],s=e.find(n=>n.name===i||n.alias===i);return s!==void 0?{argName:s.name,argValue:t[3],option:s}:{}},E=Ne;var Ae=o=>o.type?.name==="Boolean",h=Ae;var z=(o,e)=>{if(e.type===void 0)return o;if(e.type.name==="Boolean"){if(o==="true"||o==="1")return e.type(!0);if(o==="false"||o==="0")return e.type(!1)}return e.type(o)},Le=new Set(["1","0","true","false"]),Pe=(o,e)=>{let t=(i,s)=>{let{argName:n,argValue:r,option:a}=E(s,e),{lastOption:l}=i;return a&&h(a)&&r&&n?i.partial[n]=z(r,a):i.lastName&&l&&h(l)&&Le.has(s)&&(i.partial[i.lastName]=z(s,l)),{lastName:n,lastOption:a,partial:i.partial}};return o.reduce(t,{partial:{}}).partial},Q=Pe;var _e=o=>{let e=o.type?o.type.name.toLowerCase():"string",t=o.multiple??o.lazyMultiple?"[]":"";return e&&(e=e==="boolean"?"":`{underline ${e}${t}}`),e},Re=o=>(h(o)||(o.typeLabel=o.typeLabel??_e(o),o.defaultOption&&(o.typeLabel=`${o.typeLabel} (D)`),o.required&&(o.typeLabel=`${o.typeLabel} (R)`)),o),X=Re;var $e=new Set(["1","0","true","false"]),Se=(o,e)=>{let t=(i,s)=>{let{argValue:n,option:r}=E(s,e),{lastOption:a}=i;if(a&&h(a)&&$e.has(s)){let l=[...i.args];return l.pop(),{args:l}}return r&&h(r)&&n?{args:i.args}:{args:[...i.args,s],lastOption:r}};return o.reduce(t,{args:[]}).args},Z=Se;var De=new RegExp(/^-([^\d-])$/),Ve=new RegExp(/^--(\S+)/),Be=new RegExp(/^-([^\d-]{2,})$/),Ue=o=>De.test(o)||Ve.test(o)||Be.test(o),ke=(o,e)=>{let t=e[0]&&Ue(e[0])||e.length===0?null:e.shift()??null;if(!o.includes(t)){let i=new Error(`Command not recognised: ${t}`);throw i.command=t,i.name="INVALID_COMMAND",i}return {argv:e,command:t}},ee=ke;var je=(o,e)=>fastestLevenshtein.distance(o,e)<=o.length/3||e.includes(o),Ye=(o,e)=>{let t=o.toLowerCase();return e.filter(i=>je(i.toLowerCase(),t))},R=Ye;var Fe=(o,e)=>o.filter(t=>t.required&&e[t.name]==null).filter(t=>t.type?.name==="Boolean"?(e[t.name]=!1,!1):!0),te=Fe;var Ge=o=>{let e=new Map;return o.forEach(t=>{e.set(t.name,{...e.get(t.name),...t});}),[...e.values()]},oe=Ge;var qe=()=>!!process.versions.electron,Je=()=>qe()&&!process.defaultApp,We=()=>Je()?0:1,He=o=>o.slice(We()+1),ne=He;var Ke=" ",ze=(o,e)=>o.length===e.length&&o.every((t,i)=>t===e[i]),Qe=o=>typeof o=="string"?o.split(Ke):ze(o,process.argv)?ne(o):o,ie=Qe;var Xe=o=>{process.on("uncaughtException",e=>{o.error(`Uncaught exception: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);}),process.on("unhandledRejection",e=>{o.error(`Promise rejection: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);});},se=Xe;var ct="CI"in process$1.env&&("GITHUB_ACTIONS"in process$1.env||"GITLAB_CI"in process$1.env||"CIRCLECI"in process$1.env),S=process$1.env.NODE_ENV==="test"||process$1.env.TEST!=="false",dt=o=>o.charAt(0).toLowerCase()+o.slice(1),D=class{logger;argv;cwd;cliName;packageVersion;packageName;extensions=[];commands;defaultCommand;updateNotifierOptions;commandSection;constructor(e,t={}){let{argv:i,cwd:s,packageName:n,packageVersion:r}={argv:process$1.argv,cwd:process$1.cwd(),...t};this.argv=ie(i),this.argv.includes("--quiet")||this.argv.includes("-q")?process$1.env.CEREBRO_OUTPUT_LEVEL=String(16):this.argv.includes("--verbose")||this.argv.includes("-v")?process$1.env.CEREBRO_OUTPUT_LEVEL=String(64):this.argv.includes("--debug")||this.argv.includes("-vvv")||"DEBUG"in process$1.env?process$1.env.CEREBRO_OUTPUT_LEVEL=String(128):process$1.env.CEREBRO_OUTPUT_LEVEL=String(32);let a={32:"informational",64:"trace",128:"debug"};this.logger=server.createPail({logLevel:process$1.env.CEREBRO_OUTPUT_LEVEL?a[process$1.env.CEREBRO_OUTPUT_LEVEL]??"informational":"informational",...t.logger}),process$1.env.CEREBRO_OUTPUT_LEVEL===String(16)&&this.logger.disable(),K(),se(this.logger),this.cliName=e,this.packageVersion=r,this.packageName=n,this.cwd=s,this.defaultCommand="help",this.commandSection={header:`${this.cliName}${this.packageVersion?` v${this.packageVersion}`:""}`},this.commands=new Map,this.addCoreExtensions(),this.addCommand(W),this.addCommand(new J(this.commands));}setCommandSection(e){return this.commandSection=e,this}getCommandSection(){return this.commandSection}setDefaultCommand(e){return this.defaultCommand=e,this}addCommand(e){if(this.commands.has(e.name))throw new Error(`Ignored command with name "${e.name}, it was found in the command list."`);if(e.options?.map(t=>X(t)),this.validateDoubleOptions(e),this.addNegatableOption(e),e.options?.forEach(t=>{t.__camelCaseName__=I(t.name);}),this.commands.set(e.name,e),e.alias!==void 0){let t=e.alias;typeof e.alias=="string"&&(t=[e.alias]),t.forEach(i=>{if(this.logger.debug("adding alias",i),this.commands.has(i))throw new Error(`Ignoring command alias "${i}, command with the same name was found."`);this.commands.set(i,e);});}return this}addExtension(e){return this.extensions.push(e),this}enableUpdateNotifier(e={}){if(!this.packageName||!this.packageVersion)throw new Error("Cannot enable update notifier without package name and version.");let t=Object.keys(e);if(t.length>0&&!t.includes("alwaysRun")&&!t.includes("distTag")&&!t.includes("updateCheckInterval"))throw new Error("Invalid update notifier options, please check the documentation.");return this.updateNotifierOptions={alwaysRun:!1,debug:process$1.env.CEREBRO_OUTPUT_LEVEL===String(128),distTag:"latest",pkg:{name:this.packageName,version:this.packageVersion},updateCheckInterval:1e3*60*60*24,...e},this}getCliName(){return this.cliName}getPackageVersion(){return this.packageVersion}getPackageName(){return this.packageName}getCommands(){return this.commands}getCwd(){return this.cwd}async run(e={}){let t=[...this.commands.keys()],i;this.logger.debug(`process.execPath: ${process$1.execPath}`),this.logger.debug(`process.execArgv: ${process$1.execArgv.join(" ")}`),this.logger.debug(`process.argv: ${process$1.argv.join(" ")}`);try{i=ee([null,...t],this.argv);}catch(f){if(f.name==="INVALID_COMMAND"&&f.command){let V="",B=R(f.command,[...this.commands.keys()]);B.length>0&&(V=` Did you mean: \r
    - ${B.join(`    \r
- `)}`),this.logger.error(`"${f.command}" is not an available command.${V}`);}else this.logger.error(f);return S?void 0:process$1.exit(1)}let s=i.command??this.defaultCommand,n=this.commands.get(s);if(typeof n.execute!="function")return this.logger.error(`Command "${n.name}" has no function to execute.`),S?void 0:process$1.exit(1);let r=i.argv;this.logger.debug(`command '${s}' found, parsing command args: ${r.join(", ")}`);let a=oe([...n.options??[],...y]);a.forEach(f=>{if(f.multiple&&f.lazyMultiple)throw new Error(`Argument "${f.name}" cannot have both multiple and lazyMultiple options, please choose one.`)}),n.argument&&(this.logger.debug("command has positional argument, parsing them..."),a=[{defaultOption:!0,description:n.argument?.description,group:"positionals",multiple:!0,name:O,type:n.argument?.type,typeLabel:n.argument?.typeLabel},...a]);let l=mt__default.default(a,{argv:Z(r,n.options??[]),camelCase:!0,partial:!0,stopAtFirstUnknown:!0}),c=Q(r,n.options??[]),u={...l,_all:{...l._all,...c}};this.validateCommandOptions(a,u,n);let g=new H(n.name,n);g.runtime=this,await this.registerExtensions(g),await this.updateNotifier(g);let{_all:b,positionals:pe}=u;return b[O]&&delete b[O],g.argument=pe?.[O]??[],g.argv=this.argv,g.options={...b,...e},this.mapNegatableOptions(g,n),this.mapImpliesOptions(g,n),this.validateCommandArgsForConflicts(a,g.options,n),this.logger.debug("command options parsed from options:"),this.logger.debug(JSON.stringify(g.options,null,2)),this.logger.debug("command argument parsed from argument:"),this.logger.debug(JSON.stringify(g.argument,null,2)),await this.prepareToolboxResult(u,g,n),S?void 0:process$1.exit(0)}validateDoubleOptions(e){if(Array.isArray(e.options)){let t=e.options.reduce((n,r)=>{let a=`${r.name}-${r.alias}`;return n[a]||(n[a]=[]),n[a].push(r),n},{}),i=Object.values(t).filter(n=>n.length>1),s="";if(i.forEach(n=>{let r=n[0],a=n[1],l="alias";r.name===a.name&&(l="name",r.alias===a.alias&&(l+=" and alias")),s+=`Cannot add option ${l} "${JSON.stringify(a)}" to command "${e.name}" due to conflicting option ${JSON.stringify(r)}
`;}),s.length>0)throw new Error(s)}}addCoreExtensions(){this.addExtension({execute:e=>{e.logger=this.logger;},name:"logger"});}async prepareToolboxResult(e,t,i){if(e.global?.help){this.logger.debug("'--help' option found, running 'help' for given command...");let s=this.commands.get("help");if(!s)throw new Error("Help command not found.");await s.execute(t);return}if(e.global?.version||e.global?.V){this.logger.debug("'--version' option found, running 'version' for given command...");let s=this.commands.get("version");if(!s)throw new Error("Version command not found.");await s.execute(t);return}await i.execute(t);}async updateNotifier({logger:e}){if(this.updateNotifierOptions&&this.updateNotifierOptions.alwaysRun||!(process$1.env.NO_UPDATE_NOTIFIER||process$1.env.NODE_ENV==="test"||this.argv.includes("--no-update-notifier")||ct)&&this.updateNotifierOptions){e.raw("Checking for updates...");let i=await(await import('./has-new-version-RHNN4QW4.cjs').then(s=>s.default))(this.updateNotifierOptions);if(i){let s="Update available "+colorize.dim(this.packageVersion+"")+colorize.reset(" \u2192 ")+colorize.green(i);this.logger.error(boxen.boxen(s,{borderColor:n=>colorize.yellow(n),borderStyle:"round",margin:1,padding:1,textAlignment:"center"}));}}}validateCommandOptions(e,t,i){let s=te(e,t);if(s.length>0)throw new Error(`You called the command "${i.name}" without the required options: ${s.map(n=>n.name).join(", ")}`);if(t._unknown&&t._unknown.length>0){let n=[];if(t._unknown.forEach(r=>{let a=r.startsWith("--"),l=`Found unknown ${a?"option":"argument"} "${r}"`;if(a){let c=R(r.replace("--",""),[...(i.options??[]).map(u=>u.name),...y.map(u=>u.name)]);if(c.length>0){let[u,...g]=c.map(b=>`--${b}`);l+=g.length>0?`, did you mean ${u} or ${g.join(", ")}?`:`, did you mean ${u}?`;}}n.push(l);}),n.length>0)throw new Error(n.join(`
`))}}validateCommandArgsForConflicts(e,t,i){let s=e.filter(n=>n.conflicts!==void 0);if(s.length>0){let n=s.find(r=>Array.isArray(r.conflicts)?r.conflicts.some(a=>t[a]!==void 0):t[r.conflicts]!==void 0);if(n)throw new Error(`You called the command "${i.name}" with conflicting options: ${n.name} and ${typeof n.conflicts=="string"?n.conflicts:n.conflicts?.join(", ")}`)}}addNegatableOption(e){Array.isArray(e.options)&&e.options.forEach(t=>{if(t.name.startsWith("no-")&&!e.options.some(i=>i.name===t.name.replace("no-",""))){if(t.type!==Boolean){this.logger.debug(`Cannot add negated option "${t.name}" to command "${e.name}" because it is not a boolean.`);return}let i={...t,defaultValue:t.defaultValue===void 0?!0:!t.defaultValue,name:`${t.name.replace("no-","")}`};e.options.push(i);}});}async registerExtensions(e){let t=async i=>typeof i.execute!="function"?(this.logger.warn(`Skipped ${i.name} because execute is not a function.`),null):(await i.execute(e),null);for(let i of this.extensions)await t(i);}mapNegatableOptions(e,t){Object.entries(e.options).forEach(([i,s])=>{if(/^no\w+/.test(i)){let n=dt(i.replace("no",""));this.logger.debug(`mapping negated option "${i}" to "${n}"`),e.options[n]=!s,t.options?.forEach(r=>{r.name===n&&(r.__negated__=!0);});}});}mapImpliesOptions(e,t){Object.keys(e.options).forEach(i=>{let s=t.options?.find(n=>n.__camelCaseName__===i&&n.__negated__===void 0&&n.implies!==void 0);if(s?.implies){let n=s.implies;Object.entries(n).forEach(([r,a])=>{if(e.options[r]===void 0)e.options[r]=a;else {let l=t.options?.find(c=>c.name===r);(l?.defaultValue===void 0||e.options[r]===l.defaultValue)&&(e.options[r]=a);}});}});}};

module.exports = D;
//# sourceMappingURL=out.js.map

module.exports = module.exports;
//# sourceMappingURL=index.cjs.map