import { env, argv, cwd, execPath, execArgv, exit } from 'node:process';
import { boxen } from '@visulima/boxen';
import { dim, reset, green, yellow, bold } from '@visulima/colorize';
import { createPail } from '@visulima/pail/server';
import ct from 'command-line-args';
import N from 'cli-table3';
import be from '@visulima/colorize/template';
import Ce from 'node:os';
import { distance } from 'fastest-levenshtein';

var ce=/[\p{Lu}]/u,de=/[\p{Ll}]/u,k=/^[\p{Lu}](?![\p{Lu}])/gu,Y=/([\p{Alpha}\p{N}_]|$)/u,I=/[_.\- ]+/,ge=new RegExp("^"+I.source),M=new RegExp(I.source+Y.source,"gu"),j=new RegExp("\\d+"+Y.source,"gu"),ue=(o,e,t,i)=>{let s=!1,n=!1,r=!1,a=!1;for(let l=0;l<o.length;l++){let d=o[l];a=l>2?o[l-3]==="-":!0,s&&ce.test(d)?(o=o.slice(0,l)+"-"+o.slice(l),s=!1,r=n,n=!0,l++):n&&r&&de.test(d)&&(!a||i)?(o=o.slice(0,l-1)+"-"+o.slice(l-1),r=n,n=!1,s=!0):(s=e(d)===d&&t(d)!==d,r=n,n=t(d)===d&&e(d)!==d);}return o},fe=(o,e)=>(k.lastIndex=0,o.replaceAll(k,t=>e(t))),he=(o,e)=>(M.lastIndex=0,j.lastIndex=0,o.replaceAll(j,(t,i,s)=>["_","-"].includes(o.charAt(s+t.length))?t:e(t)).replaceAll(M,(t,i)=>e(i)));function x(o,e){if(!(typeof o=="string"||Array.isArray(o)))throw new TypeError("Expected the input to be `string | string[]`");if(e={pascalCase:!1,preserveConsecutiveUppercase:!1,...e},Array.isArray(o)?o=o.map(n=>n.trim()).filter(n=>n.length).join("-"):o=o.trim(),o.length===0)return "";let t=e.locale===!1?n=>n.toLowerCase():n=>n.toLocaleLowerCase(e.locale),i=e.locale===!1?n=>n.toUpperCase():n=>n.toLocaleUpperCase(e.locale);return o.length===1?I.test(o)?"":e.pascalCase?i(o):t(o):(o!==t(o)&&(o=ue(o,t,i,e.preserveConsecutiveUppercase)),o=o.replace(ge,""),o=e.preserveConsecutiveUppercase?fe(o,t):t(o),e.pascalCase&&(o=i(o.charAt(0))+o.slice(1)),he(o,i))}var ye=[{description:"Turn on verbose output",group:"global",name:"verbose",type:Boolean},{description:"Turn on debugging output",group:"global",name:"debug",type:Boolean},{alias:"h",description:"Print out helpful usage information",group:"global",name:"help",type:Boolean},{alias:"q",description:"Silence output",group:"global",name:"quiet",type:Boolean},{alias:"V",description:"Print version info",group:"global",name:"version",type:Boolean},{description:"Turn off colored output",group:"global",name:"no-color",type:Boolean},{description:"Force colored output",group:"global",name:"color",type:Boolean}],b=ye;var Oe=o=>o?be(Object.assign([],{raw:[o.replaceAll("`","\\`")]})):"",c=Oe;var w=class{lines;constructor(){this.lines=[];}add(e){this.lines.push(e);}toString(){return this.lines.join(Ce.EOL)}header(e){this.add(bold(e)),this.lines.push("");}},T=w;var E={chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,60],style:{border:[],compact:!0,head:[],"padding-left":2,"padding-right":1},wordWrap:!0},A=class extends T{constructor(e){if(super(),e.header&&this.header(c(e.header)),e.content){if(e.raw)if(Array.isArray(e.content)&&e.content.every(t=>typeof t=="string"))e.content.forEach(t=>{Array.isArray(t)?t.forEach(i=>this.add(c(i))):this.add(c(t));});else if(typeof e.content=="string")this.add(c(e.content));else throw new TypeError("Invalid raw content, must be a string or array of strings.");else this.add(this.getContentLines(e.content));this.add("");}}getContentLines(e){if(typeof e=="string"){let t=new N({...E,colWidths:[80]});return t.push([c(e)]),t.toString()}if(Array.isArray(e)&&e.every(t=>typeof t=="string"||Array.isArray(t)&&t.every(i=>typeof i=="string"))){let t=new N({...E});return e.forEach(i=>{Array.isArray(i)?t.push(i.map(s=>c(s))):t.push([c(i)]);}),t.toString()}if(typeof e=="object"){let t=e;if(!t.options||!t.data)throw new Error(`Must have an "options" or "data" property
${JSON.stringify(e)}`);let i=new N({...E,...t.options,style:{...E.style,...t.options.style}});return t.data.forEach(s=>{Array.isArray(s)?i.push(s.map(n=>c(n))):i.push([c(s)]);}),i.toString()}throw new Error(`invalid input - 'content' must be a string, array of strings or a object:

${JSON.stringify(e)}`)}},F=A;var L=class extends T{constructor(e){super();let t=e.optionList??[],i=Array.isArray(e.hide)?e.hide:[e.hide].filter(Boolean),s=Array.isArray(e.group)?e.group:[e.group].filter(Boolean);i.length>0&&(t=t.filter(r=>!i.includes(r.name))),e.header&&this.header(c(e.header)),s.length>0&&(t=t.filter(r=>{let a=s.includes("_none")&&!r.group,l=this.intersect(Array.isArray(r.group)?r.group:[r.group],s);return a||l?r:void 0}));let n=new N({chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,40],style:{"padding-left":2,"padding-right":1},wordWrap:!0});t.forEach(r=>n.push([this.getOptionNames(r,e.reverseNameOrder??!1,e.isArgument??!1),c(r.description)])),this.add(n.toString()),this.lines.push("");}getOptionNames(e,t,i){if(!e.name)throw new TypeError("Invalid option definition, name is required.");let s=e.type?e.type.name.toLowerCase():"string",n=e.multiple||e.lazyMultiple?"[]":"";s=c(e.typeLabel??`{underline ${s}${n}}`);let r;if(e.alias)if(e.name){let a=i?e.name:`{yellow --${e.name}}`;r=t?c(`{bold ${a}}, {bold -${e.alias}} ${s}`):c(`{bold -${e.alias}}, {bold ${a}} ${s}`);}else t?r=c(`{bold -${e.alias}} ${s}`):r=c(`{bold -${e.alias}} ${s}`);else r=c(`{bold ${i?e.name:`{yellow --${e.name}}`}} ${s}`);return r}intersect(e,t){return e.some(i=>t.includes(i))}},G=L;var ve=o=>(Array.isArray(o)?o:[o]).length===0?"":`
${o.map(t=>t.optionList?new G(t).toString():new F(t).toString()).join(`
`)}`,P=ve;var q="__Other",J=o=>o.charAt(0).toUpperCase()+o.slice(1),Ie=(o,e,t,i)=>{o.debug("no command given, printing general help...");let s=[...new Set(t.values())].filter(r=>!r.hidden);i&&(s=s.filter(r=>r.group===i));let n=s.reduce((r,a)=>{let l=a.group??q;return r[l]||(r[l]=[]),r[l].push(a),r},{});o.raw(P([{content:`{cyan ${e.getCliName()}} {green <command>} [positional arguments] {yellow [options]}`,header:"{inverse.cyan  Usage }"},...Object.keys(n).map(r=>({content:n[r].map(a=>{let l="";return typeof a.alias=="string"?l=a.alias:Array.isArray(a.alias)&&(l=a.alias.join(", ")),l!==""&&(l=` [${l}]`),[`{green ${a.name}} ${l}`,a.description??""]}),header:r===q||i?`{inverse.green  Available${i?` ${J(i)}`:""} Commands }`:` {inverse.green  ${J(r)} }`})),t.has("help")?{header:"{inverse.yellow  Command Options }",optionList:t.get("help").options?.filter(r=>!r.hidden)}:void 0,{header:"{inverse.yellow  Global Options }",optionList:b},{content:`Run "{cyan ${e.getCliName()}} {green help <command>}" or "{cyan ${e.getCliName()}} {green <command>} {yellow --help}" for help with a specific command.`,raw:!0}].filter(Boolean)));},xe=(o,e,t,i)=>{let s=t.get(i),n=[];if(n.push({content:`{cyan ${e.getCliName()}} {green ${s.name}}${s.argument?" [positional arguments]":""}${s.options?" [options]":""}`,header:"{inverse.cyan  Usage }"}),s.description&&n.push({content:s.description,header:"{inverse.green  Description }"}),s.argument&&n.push({header:"Command Positional Arguments",isArgument:!0,optionList:[s.argument]}),Array.isArray(s.options)&&s.options.length>0&&n.push({header:"{inverse.yellow  Command Options }",optionList:s.options.filter(r=>!r.hidden)}),n.push({header:"{inverse.yellow  Global Options }",optionList:b}),s.alias!==void 0&&s.alias.length>0){let r=s.alias;typeof s.alias=="string"&&(r=[s.alias]),n.splice(1,0,{content:r,header:"Alias(es)"});}Array.isArray(s.examples)&&s.examples.length>0&&n.push({content:s.examples,header:"Examples"}),o.raw(P(n));},_=class{name="help";options=[{description:"Display only the specified group",name:"group",type:String}];commands;constructor(e){this.commands=e;}execute(e){let{commandName:t,logger:i,options:s,runtime:n}=e,{footer:r,header:a}=n.getCommandSection();a&&i.raw(c(a)),t==="help"?Ie(i,n,this.commands,s?.group):xe(i,n,this.commands,t),r&&i.raw(c(r));}},W=_;var H={alias:["v","V"],description:"Output the version number",execute:({logger:o,runtime:e})=>{let t=e.getPackageVersion();t===void 0?(o.warn("Unknown version"),o.debug("The version number was not provided by the cli constructor.")):o.info(t);},name:"version",options:[],usage:[]};var C="positionals";var R=class{result;argv;options;argument;command;commandName;runtime;logger;constructor(e,t){this.commandName=e,this.command=t;}},K=R;var we=()=>{let o=process.env.CEREBRO_MIN_NODE_VERSION?Number(process.env.CEREBRO_MIN_NODE_VERSION):18,e=process.version.replace("v","");Number(/v([^.]+)/.exec(process.version)[1])<o&&(console.log(`cerebro supports a minimum Node version of ${o}. You have ${e}. Read our version support policy: https://github.com/visulima/visulima#supported-nodejs-versions`),process.exit(1));},z=we;var Ne=/^-{1,2}(\w+)(=(\w+))?$/,Ae=(o,e)=>{let t=Ne.exec(o);if(t==null)return {};let i=t[1],s=e.find(n=>n.name===i||n.alias===i);return s!==void 0?{argName:s.name,argValue:t[3],option:s}:{}},v=Ae;var Le=o=>o.type?.name==="Boolean",y=Le;var Q=(o,e)=>{if(e.type===void 0)return o;if(e.type.name==="Boolean"){if(o==="true"||o==="1")return e.type(!0);if(o==="false"||o==="0")return e.type(!1)}return e.type(o)},Pe=new Set(["1","0","true","false"]),_e=(o,e)=>{let t=(i,s)=>{let{argName:n,argValue:r,option:a}=v(s,e),{lastOption:l}=i;return a&&y(a)&&r&&n?i.partial[n]=Q(r,a):i.lastName&&l&&y(l)&&Pe.has(s)&&(i.partial[i.lastName]=Q(s,l)),{lastName:n,lastOption:a,partial:i.partial}};return o.reduce(t,{partial:{}}).partial},X=_e;var Re=o=>{let e=o.type?o.type.name.toLowerCase():"string",t=o.multiple??o.lazyMultiple?"[]":"";return e&&(e=e==="boolean"?"":`{underline ${e}${t}}`),e},$e=o=>(y(o)||(o.typeLabel=o.typeLabel??Re(o),o.defaultOption&&(o.typeLabel=`${o.typeLabel} (D)`),o.required&&(o.typeLabel=`${o.typeLabel} (R)`)),o),Z=$e;var Se=new Set(["1","0","true","false"]),De=(o,e)=>{let t=(i,s)=>{let{argValue:n,option:r}=v(s,e),{lastOption:a}=i;if(a&&y(a)&&Se.has(s)){let l=[...i.args];return l.pop(),{args:l}}return r&&y(r)&&n?{args:i.args}:{args:[...i.args,s],lastOption:r}};return o.reduce(t,{args:[]}).args},ee=De;var Ve=new RegExp(/^-([^\d-])$/),Be=new RegExp(/^--(\S+)/),Ue=new RegExp(/^-([^\d-]{2,})$/),ke=o=>Ve.test(o)||Be.test(o)||Ue.test(o),Me=(o,e)=>{let t=e[0]&&ke(e[0])||e.length===0?null:e.shift()??null;if(!o.includes(t)){let i=new Error(`Command not recognised: ${t}`);throw i.command=t,i.name="INVALID_COMMAND",i}return {argv:e,command:t}},te=Me;var Ye=(o,e)=>distance(o,e)<=o.length/3||e.includes(o),Fe=(o,e)=>{let t=o.toLowerCase();return e.filter(i=>Ye(i.toLowerCase(),t))},$=Fe;var Ge=(o,e)=>o.filter(t=>t.required&&e[t.name]==null).filter(t=>t.type?.name==="Boolean"?(e[t.name]=!1,!1):!0),oe=Ge;var qe=o=>{let e=new Map;return o.forEach(t=>{e.set(t.name,{...e.get(t.name),...t});}),[...e.values()]},ne=qe;var Je=()=>!!process.versions.electron,We=()=>Je()&&!process.defaultApp,He=()=>We()?0:1,Ke=o=>o.slice(He()+1),ie=Ke;var ze=" ",Qe=(o,e)=>o.length===e.length&&o.every((t,i)=>t===e[i]),Xe=o=>typeof o=="string"?o.split(ze):Qe(o,process.argv)?ie(o):o,se=Xe;var Ze=o=>{process.on("uncaughtException",e=>{o.error(`Uncaught exception: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);}),process.on("unhandledRejection",e=>{o.error(`Promise rejection: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);});},re=Ze;var dt="CI"in env&&("GITHUB_ACTIONS"in env||"GITLAB_CI"in env||"CIRCLECI"in env),D=env.NODE_ENV==="test"||env.TEST!=="false",gt=o=>o.charAt(0).toLowerCase()+o.slice(1),V=class{logger;argv;cwd;cliName;packageVersion;packageName;extensions=[];commands;defaultCommand;updateNotifierOptions;commandSection;constructor(e,t={}){let{argv:i,cwd:s,packageName:n,packageVersion:r}={argv:argv,cwd:cwd(),...t};this.argv=se(i),this.argv.includes("--quiet")||this.argv.includes("-q")?env.CEREBRO_OUTPUT_LEVEL=String(16):this.argv.includes("--verbose")||this.argv.includes("-v")?env.CEREBRO_OUTPUT_LEVEL=String(64):this.argv.includes("--debug")||this.argv.includes("-vvv")||"DEBUG"in env?env.CEREBRO_OUTPUT_LEVEL=String(128):env.CEREBRO_OUTPUT_LEVEL=String(32);let a={32:"informational",64:"trace",128:"debug"};this.logger=createPail({logLevel:env.CEREBRO_OUTPUT_LEVEL?a[env.CEREBRO_OUTPUT_LEVEL]??"informational":"informational",...t.logger}),env.CEREBRO_OUTPUT_LEVEL===String(16)&&this.logger.disable(),z(),re(this.logger),this.cliName=e,this.packageVersion=r,this.packageName=n,this.cwd=s,this.defaultCommand="help",this.commandSection={header:`${this.cliName}${this.packageVersion?` v${this.packageVersion}`:""}`},this.commands=new Map,this.addCoreExtensions(),this.addCommand(H),this.addCommand(new W(this.commands));}setCommandSection(e){return this.commandSection=e,this}getCommandSection(){return this.commandSection}setDefaultCommand(e){return this.defaultCommand=e,this}addCommand(e){if(this.commands.has(e.name))throw new Error(`Ignored command with name "${e.name}, it was found in the command list."`);if(e.options?.map(t=>Z(t)),this.validateDoubleOptions(e),this.addNegatableOption(e),e.options?.forEach(t=>{t.__camelCaseName__=x(t.name);}),this.commands.set(e.name,e),e.alias!==void 0){let t=e.alias;typeof e.alias=="string"&&(t=[e.alias]),t.forEach(i=>{if(this.logger.debug("adding alias",i),this.commands.has(i))throw new Error(`Ignoring command alias "${i}, command with the same name was found."`);this.commands.set(i,e);});}return this}addExtension(e){return this.extensions.push(e),this}enableUpdateNotifier(e={}){if(!this.packageName||!this.packageVersion)throw new Error("Cannot enable update notifier without package name and version.");let t=Object.keys(e);if(t.length>0&&!t.includes("alwaysRun")&&!t.includes("distTag")&&!t.includes("updateCheckInterval"))throw new Error("Invalid update notifier options, please check the documentation.");return this.updateNotifierOptions={alwaysRun:!1,debug:env.CEREBRO_OUTPUT_LEVEL===String(128),distTag:"latest",pkg:{name:this.packageName,version:this.packageVersion},updateCheckInterval:1e3*60*60*24,...e},this}getCliName(){return this.cliName}getPackageVersion(){return this.packageVersion}getPackageName(){return this.packageName}getCommands(){return this.commands}getCwd(){return this.cwd}async run(e={}){let t=[...this.commands.keys()],i;this.logger.debug(`process.execPath: ${execPath}`),this.logger.debug(`process.execArgv: ${execArgv.join(" ")}`),this.logger.debug(`process.argv: ${argv.join(" ")}`);try{i=te([null,...t],this.argv);}catch(h){if(h.name==="INVALID_COMMAND"&&h.command){let B="",U=$(h.command,[...this.commands.keys()]);U.length>0&&(B=` Did you mean: \r
    - ${U.join(`    \r
- `)}`),this.logger.error(`"${h.command}" is not an available command.${B}`);}else this.logger.error(h);return D?void 0:exit(1)}let s=i.command??this.defaultCommand,n=this.commands.get(s);if(typeof n.execute!="function")return this.logger.error(`Command "${n.name}" has no function to execute.`),D?void 0:exit(1);let r=i.argv;this.logger.debug(`command '${s}' found, parsing command args: ${r.join(", ")}`);let a=ne([...n.options??[],...b]);a.forEach(h=>{if(h.multiple&&h.lazyMultiple)throw new Error(`Argument "${h.name}" cannot have both multiple and lazyMultiple options, please choose one.`)}),n.argument&&(this.logger.debug("command has positional argument, parsing them..."),a=[{defaultOption:!0,description:n.argument?.description,group:"positionals",multiple:!0,name:C,type:n.argument?.type,typeLabel:n.argument?.typeLabel},...a]);let l=ct(a,{argv:ee(r,n.options??[]),camelCase:!0,partial:!0,stopAtFirstUnknown:!0}),d=X(r,n.options??[]),f={...l,_all:{...l._all,...d}};this.validateCommandOptions(a,f,n);let u=new K(n.name,n);u.runtime=this,await this.registerExtensions(u),await this.updateNotifier(u);let{_all:O,positionals:me}=f;return O[C]&&delete O[C],u.argument=me?.[C]??[],u.argv=this.argv,u.options={...O,...e},this.mapNegatableOptions(u,n),this.mapImpliesOptions(u,n),this.validateCommandArgsForConflicts(a,u.options,n),this.logger.debug("command options parsed from options:"),this.logger.debug(JSON.stringify(u.options,null,2)),this.logger.debug("command argument parsed from argument:"),this.logger.debug(JSON.stringify(u.argument,null,2)),await this.prepareToolboxResult(f,u,n),D?void 0:exit(0)}validateDoubleOptions(e){if(Array.isArray(e.options)){let t=e.options.reduce((n,r)=>{let a=`${r.name}-${r.alias}`;return n[a]||(n[a]=[]),n[a].push(r),n},{}),i=Object.values(t).filter(n=>n.length>1),s="";if(i.forEach(n=>{let r=n[0],a=n[1],l="alias";r.name===a.name&&(l="name",r.alias===a.alias&&(l+=" and alias")),s+=`Cannot add option ${l} "${JSON.stringify(a)}" to command "${e.name}" due to conflicting option ${JSON.stringify(r)}
`;}),s.length>0)throw new Error(s)}}addCoreExtensions(){this.addExtension({execute:e=>{e.logger=this.logger;},name:"logger"});}async prepareToolboxResult(e,t,i){if(e.global?.help){this.logger.debug("'--help' option found, running 'help' for given command...");let s=this.commands.get("help");if(!s)throw new Error("Help command not found.");await s.execute(t);return}if(e.global?.version||e.global?.V){this.logger.debug("'--version' option found, running 'version' for given command...");let s=this.commands.get("version");if(!s)throw new Error("Version command not found.");await s.execute(t);return}await i.execute(t);}async updateNotifier({logger:e}){if(this.updateNotifierOptions&&this.updateNotifierOptions.alwaysRun||!(env.NO_UPDATE_NOTIFIER||env.NODE_ENV==="test"||this.argv.includes("--no-update-notifier")||dt)&&this.updateNotifierOptions){e.raw("Checking for updates...");let i=await(await import('./has-new-version-UY375FY3.js').then(s=>s.default))(this.updateNotifierOptions);if(i){let s="Update available "+dim(this.packageVersion+"")+reset(" \u2192 ")+green(i);this.logger.error(boxen(s,{borderColor:n=>yellow(n),borderStyle:"round",margin:1,padding:1,textAlignment:"center"}));}}}validateCommandOptions(e,t,i){let s=oe(e,t);if(s.length>0)throw new Error(`You called the command "${i.name}" without the required options: ${s.map(n=>n.name).join(", ")}`);if(t._unknown&&t._unknown.length>0){let n=[];if(t._unknown.forEach(r=>{let a=r.startsWith("--"),l=`Found unknown ${a?"option":"argument"} "${r}"`;if(a){let d=$(r.replace("--",""),[...(i.options??[]).map(f=>f.name),...b.map(f=>f.name)]);if(d.length>0){let[f,...u]=d.map(O=>`--${O}`);l+=u.length>0?`, did you mean ${f} or ${u.join(", ")}?`:`, did you mean ${f}?`;}}n.push(l);}),n.length>0)throw new Error(n.join(`
`))}}validateCommandArgsForConflicts(e,t,i){let s=e.filter(n=>n.conflicts!==void 0);if(s.length>0){let n=s.find(r=>Array.isArray(r.conflicts)?r.conflicts.some(a=>t[a]!==void 0):t[r.conflicts]!==void 0);if(n)throw new Error(`You called the command "${i.name}" with conflicting options: ${n.name} and ${typeof n.conflicts=="string"?n.conflicts:n.conflicts?.join(", ")}`)}}addNegatableOption(e){Array.isArray(e.options)&&e.options.forEach(t=>{if(t.name.startsWith("no-")&&!e.options.some(i=>i.name===t.name.replace("no-",""))){if(t.type!==Boolean){this.logger.debug(`Cannot add negated option "${t.name}" to command "${e.name}" because it is not a boolean.`);return}let i={...t,defaultValue:t.defaultValue===void 0?!0:!t.defaultValue,name:`${t.name.replace("no-","")}`};e.options.push(i);}});}async registerExtensions(e){let t=async i=>typeof i.execute!="function"?(this.logger.warn(`Skipped ${i.name} because execute is not a function.`),null):(await i.execute(e),null);for(let i of this.extensions)await t(i);}mapNegatableOptions(e,t){Object.entries(e.options).forEach(([i,s])=>{if(/^no\w+/.test(i)){let n=gt(i.replace("no",""));this.logger.debug(`mapping negated option "${i}" to "${n}"`),e.options[n]=!s,t.options?.forEach(r=>{r.name===n&&(r.__negated__=!0);});}});}mapImpliesOptions(e,t){Object.keys(e.options).forEach(i=>{let s=t.options?.find(n=>n.__camelCaseName__===i&&n.__negated__===void 0&&n.implies!==void 0);if(s?.implies){let n=s.implies;Object.entries(n).forEach(([r,a])=>{if(e.options[r]===void 0)e.options[r]=a;else {let l=t.options?.find(d=>d.name===r);(l?.defaultValue===void 0||e.options[r]===l.defaultValue)&&(e.options[r]=a);}});}});}};

export { V as default };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map